<?php
/**
 * @author ykm 2015-12-15
 * @describe 淘宝请求电子面单类
 */
class erpapi_logistics_matrix_taobao_request_electron extends erpapi_logistics_request_electron
{
    protected $directNum = 10;

    public function bufferRequest($sdf){
        return $this->directNum;
    }

    public function directRequest($sdf){
        
        $this->title = '淘宝云栈_' . $this->__channelObj->channel['logistics_code'] . '获取电子面单';
        $this->timeOut = 6;
        $this->primaryBn = $sdf['primary_bn'];
        $arrDelivery = $sdf['delivery']; //发货单主表外，还需字段item_name、package_items、order_channels_type、order_bn
        $shop = $sdf['shop'];
        $trade_order_info_cols = array();
        foreach($arrDelivery as $delivery) {
            $deliveryBnKey[$delivery['delivery_bn']] = $delivery;
            $delivery_bn = (isset($delivery['outer_delivery_bn']) && !empty($delivery['outer_delivery_bn'])) ? $delivery['outer_delivery_bn'] : $delivery['delivery_bn'] ;

            $trade_order_info_cols[] = array(
                'real_user_id' => $shop['seller_id'],
                'consignee_address' => array(
                    'address_detail' => $delivery['ship_addr'],
                    'area' => $delivery['ship_district'],
                    'city' => $delivery['ship_city'],
                    'province' => $delivery['ship_province'],
                ),
                'consignee_name' => $delivery['ship_name'],
                'consignee_phone' => $delivery['ship_mobile'] != '' ? $delivery['ship_mobile'] : $delivery['ship_tel'],
                'item_name' => $delivery['item_name'],
                'package_items' => $delivery['package_items'],
                'order_channels_type' => $delivery['order_channels_type'],
                'trade_order_list' => empty($delivery['order_bn']) ? $delivery_bn : array_unique($delivery['order_bn']),
                'product_type' => 'STANDARD_EXPRESS',
                'package_id' => $delivery['delivery_bn'],

            );
        }
        $shopAddress = array(
            'province' => $shop['province'],
            'city' => $shop['city'],
            'area' => $shop['area'],
            'address_detail' => $shop['address_detail'],
        );
        #德邦快递需要加增加发货人、联系方式
        if($this->__channelObj->channel['logistics_code'] == 'DBKD') {
            foreach($trade_order_info_cols as &$val) {
                $val['send_name'] = $shop['default_sender'];#发货人姓名
                $val['send_phone'] = $shop['mobile'] ? $shop['mobile'] : $shop['tel'];#发货人联系方式
            }
            $shopAddress['default_sender'] = $shop['default_sender'];
            $shopAddress['mobile'] = $shop['mobile'];
            $shopAddress['tel'] = $shop['tel'];
        }
        $params = array(
            'is_batch'=>'true',
            'shipping_address' => json_encode($shopAddress),
            'trade_order_info_cols' => json_encode($trade_order_info_cols),
        );

        // 超时请求3次
        $requestCount = 0;
        do {
            $result = $this->requestCall(STORE_WLB_WAYBILL_I_GET, $params);
            // 判断是否请求超时
            if ($result['rsp'] != 'fail' || ($result['res_ltype'] != 1 && $result['res_ltype'] != 2) ) {
                break;
            }
            $requestCount++;
        } while ($requestCount<3);
        return $this->backToResult($result, $deliveryBnKey);
    }

    public function backToResult($ret, $deliveryBnKey){
        $data = empty($ret['data']) ? '' : json_decode($ret['data'], true);
        if(empty($data['waybill_apply_new_info'])) {
            return false;
        }
        $result = array();

        foreach ($data['waybill_apply_new_info'] as $val) {
            $deliveryBn = trim($val['trade_order_info']['package_id']);
            $delivery = $deliveryBnKey[$deliveryBn];
            $result[] = array(
                'succ' => $val['waybill_code'] ? true : false,
                'msg' => '',
                'delivery_id' => $delivery['delivery_id'],
                'delivery_bn' => $delivery['delivery_bn'],
                'logi_no' => $val['waybill_code'],
                'mailno_barcode' => '',
                'qrcode' => '',
                'position' => $val['short_address'],
                'position_no' => '',
                'package_wdjc' => $val['package_center_name'] ? $val['package_center_name'] : '',
                'package_wd' => $val['package_center_code'] ? $val['package_center_code'] : '',
                'print_config' => $val['print_config'] ? $val['print_config']:'',
                'json_packet' => '',
            );
        }
        $this->directDataProcess($result);
        return $result;
    }

    public function delivery($sdf) {
        $delivery = $sdf['delivery'];
        $shop = $sdf['shop'];
        $position = $sdf['position'];
        $this->title = '淘宝云栈_' . $this->__channelObj->channel['logistics_code'] . '电子面单物流回传';
        $this->primaryBn = $delivery['delivery_bn'];
        $logData = array(
            'logi_no' => $delivery['logi_no'],
            'delivery_id' => $delivery['delivery_id']
        );
        $shipping_address = array(
            'province' => $shop['province'],
            'city' => $shop['city'],
            'area' => $shop['area'],
            'address_detail' => $shop['address_detail'],
            'seller_id' => $shop['seller_id'],
            'default_sender' => $shop['default_sender'],
            'tel' => $shop['tel'],
            'mobile' => $shop['mobile'],
        );
        $print_check_info_cols = array(
            'consignee_name' => $delivery['ship_name'],
            'waybill_code' => $delivery['logi_no'],
            'consignee_address' => array(
                'address_detail' => $delivery['ship_addr'],
                'area' => $delivery['ship_district'],
                'city' => $delivery['ship_city'],
                //'division_id' => $delivery['ship_zip'] ? $delivery['ship_zip'] : 0,
                'province' => $delivery['ship_province'],
            ),
            'consignee_phone' => $delivery['ship_mobile'] != '' ? $delivery['ship_mobile'] : $delivery['ship_tel'],
            'shipping_address' => $shipping_address,
            'short_address' => $position,
            'real_user_id' => $shop['seller_id'],
        );
        $params = array(
            'print_check_info_cols' => json_encode($print_check_info_cols)
        );
        return $this->deliveryCall(STORE_WLB_WAYBILL_PRINT,$logData,$params);
    }
}